
local M = {}
M.type = "auxilliary"
M.relevantDevice = nil

local speedThresholdNormalPosition = 14
local speedThresholdClosedPosition = 8
local speedThresholdBrakingPosition = 0.5
local brakeThresholdBrakingPosition = 0.5
local TurningThresholdPosition = 0.2
local TurningThresholdPositionNormal = 0
local TurningThresholdPositionNegative = -0.2

local spoilerClosed = 0
local spoilerTurningLowSpeed = 0.40
local spoilerNormal = 0.60
local spoilerBraking = 1
local turning = 0

local function init()
    electrics.values.spoiler = 0
end

local function updateGFX(dt)
    local spoiler = electrics.values.spoiler
    local speed = electrics.values.wheelspeed
    local steering = electrics.values.steering_input

	if steering < TurningThresholdPositionNegative or steering > TurningThresholdPosition then turning = 1
	else turning = 0
	end
	
    if electrics.values.brake > brakeThresholdBrakingPosition then --check for brake input
        spoiler = speed >= speedThresholdBrakingPosition and spoilerBraking or spoilerClosed
    elseif speed >= speedThresholdNormalPosition and turning == 0 then --we are not braking, check for normal spoiler mode speed and if there is steering
        spoiler = spoilerNormal--(we are above the normal spoiler position speed, so set the spoiler to normal)
    elseif speed >= speedThresholdNormalPosition and turning == 1 then --check if the car is steering
        spoiler = spoilerTurningLowSpeed
    else --we are not braking AND below the normal position speed
        spoiler = (spoiler == spoilerNormal and speed >= speedThresholdClosedPosition) and spoilerNormal or spoilerClosed
    end
	

    electrics.values.spoiler = spoiler
end

M.updateGFX = updateGFX

return M